;(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined'
    ? (module.exports = factory())
    : typeof define === 'function' && define.amd
    ? define(factory)
    : ((global =
        typeof globalThis !== 'undefined' ? globalThis : global || self),
      (global.PromisifyFileReader = factory()))
})(this, function () {
  'use strict'

  // eslint-disable-next-line no-new-func
  var globalThis = new Function('return this')()
  var FileReader = globalThis.FileReader,
    Promise = globalThis.Promise,
    Blob = globalThis.Blob

  function promisify(method) {
    return function (blob, encoding) {
      return new Promise(function (resolve, reject) {
        var fileReader = new FileReader()

        fileReader.onload = function () {
          return resolve(fileReader.result)
        }

        fileReader.onerror = function () {
          return reject(fileReader.error)
        }

        method.call(fileReader, blob, encoding)
      })
    }
  }

  function toStatic(method) {
    return function (blob, encoding) {
      return method.call(blob, encoding)
    }
  }

  var readAsArrayBuffer = Blob.prototype.arrayBuffer
    ? toStatic(Blob.prototype.arrayBuffer)
    : promisify(FileReader.prototype.readAsArrayBuffer)

  var fromCharCode = String.fromCharCode

  function arrayBufferToBinaryString(buffer) {
    var bytes = new Uint8Array(buffer)
    var byteLength = bytes.byteLength
    var binary = '' // can we use a chuck size for this loop?

    for (var i = 0; i < byteLength; i += 1) {
      binary += fromCharCode(bytes[i])
    }

    return binary
  }

  function getBinaryStringFromArrayBuffer(blob) {
    return readAsArrayBuffer(blob).then(arrayBufferToBinaryString)
  } // IE 10 don't has `readAsBinaryString`

  var readAsBinaryString = FileReader.prototype.readAsBinaryString
    ? promisify(FileReader.prototype.readAsBinaryString)
    : getBinaryStringFromArrayBuffer

  var readAsDataURL = promisify(FileReader.prototype.readAsDataURL)

  var readAsText = promisify(FileReader.prototype.readAsText)

  var core = /*#__PURE__*/ Object.freeze({
    __proto__: null,
    readAsArrayBuffer: readAsArrayBuffer,
    readAsBinaryString: readAsBinaryString,
    readAsDataURL: readAsDataURL,
    readAsText: readAsText,
  })

  // eslint-disable-next-line unicorn/import-index

  var staticMethods = /*#__PURE__*/ Object.freeze({
    __proto__: null,
    readAsArrayBuffer: readAsArrayBuffer,
    readAsBinaryString: readAsBinaryString,
    readAsDataURL: readAsDataURL,
    readAsText: readAsText,
    arrayBuffer: readAsArrayBuffer,
    binaryString: readAsBinaryString,
    dataURL: readAsDataURL,
    text: readAsText,
  })

  // eslint-disable-next-line unicorn/import-index

  var FileReader$1 = function FileReader() {}

  Object.assign(FileReader$1.prototype, core)
  Object.assign(FileReader$1, staticMethods)

  return FileReader$1
})
//# sourceMappingURL=index.js.map
